/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of PortIO.xs. Do not edit this file, edit PortIO.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "PortIO.xs"
/* ======================================================================
 * PortIO.xs - XS code which exposes direct port I/O calls to Perl
 * Andrew Ho (andrew@zeuscat.com)
 *
 * See PortIO.pm for API documentation.
 *
 * Copyright (C) 2005 by Andrew Ho.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the same terms as Perl itself, either Perl version 5.6.0 or,
 * at your option, any later version of Perl 5 you may have available.
 *
 * $Id: PortIO.xs,v 1.1 2005/02/26 05:19:30 andrew Exp $
 * ====================================================================== */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* abstract architecture dependent port I/O calls using macros */
#if defined __OpenBSD__ || defined __NetBSD__

#include <machine/sysarch.h>
#include <machine/pio.h>

static struct i386_iopl_args iopls;

#define PORT_OPEN(p)    (iopls.iopl = 3, sysarch(I386_IOPL, (char *)&iopls))
#define READ_BYTE(p)    (inb(p))
#define WRITE_BYTE(p,v) (outb((p), (v)))
#define PORT_CLOSE(p)   (iopls.iopl = 0, sysarch(I386_IOPL, (char *)&iopls))

#elif defined __FreeBSD__

#include <machine/cpufunc.h>
#include <fcntl.h>

static int iofd = -1;

#define PORT_OPEN(x)    (iofd = open("/dev/io", O_RDONLY))
#define READ_BYTE(p)    (inb(p))
#define WRITE_BYTE(p,v) (outb((p), (v)))
#define PORT_CLOSE(x)   (close(iofd))

#else

#include <sys/io.h>

#define PORT_OPEN(p)    (ioperm((p), 3, 1))
#define READ_BYTE(p)    (inb(p))
#define WRITE_BYTE(p,v) (outb((v), (p)))
#define PORT_CLOSE(p)   (ioperm((p), 3, 0))

#endif


/* ---------------------------------------------------------------------- */

#line 69 "PortIO.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 213 "PortIO.c"

XS_EUPXS(XS_Sys__PortIO_port_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__PortIO_port_open)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	int	p = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 65 "PortIO.xs"
    int retval = PORT_OPEN(p);
    if(retval != 0) {
        XSRETURN_UNDEF;
    } else {
        RETVAL = 1;
    }
#line 233 "PortIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__PortIO_read_byte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__PortIO_read_byte)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	int	p = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 78 "PortIO.xs"
    int retval = READ_BYTE(p);
    if(retval == 0xff) {
        XSRETURN_UNDEF;
    } else {
        RETVAL = retval;
    }
#line 258 "PortIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__PortIO_write_byte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__PortIO_write_byte)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, v");
    {
	int	p = (int)SvIV(ST(0))
;
	int	v = (int)SvIV(ST(1))
;
#line 92 "PortIO.xs"
    WRITE_BYTE(p, v);
#line 278 "PortIO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__PortIO_port_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__PortIO_port_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	int	p = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 98 "PortIO.xs"
    int retval = PORT_CLOSE(p);
    if(retval != 0) {
        XSRETURN_UNDEF;
    } else {
        RETVAL = 1;
    }
#line 302 "PortIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Sys__PortIO); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sys__PortIO)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Sys::PortIO::port_open", XS_Sys__PortIO_port_open);
        newXS_deffile("Sys::PortIO::read_byte", XS_Sys__PortIO_read_byte);
        newXS_deffile("Sys::PortIO::write_byte", XS_Sys__PortIO_write_byte);
        newXS_deffile("Sys::PortIO::port_close", XS_Sys__PortIO_port_close);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

